# -*- coding: utf-8 -*-
"""
Created on Thu Nov  7 15:31:13 2024

@author: mstep
"""

#!/usr/bin/env python
# coding: utf-8

# In[2]:

import tkinter as tk

class ColorSlidersApp:
    def __init__(self):
        # Initialize tkinter.
        self.window = tk.Tk()
        self.window.title('color_sliders')
        self.window.protocol('WM_DELETE_WINDOW', self.kill_callback)
        self.window.geometry('300x300')

        # Red.
        self.red_scale = tk.Scale(self.window, from_=0, to=255,
            orient=tk.HORIZONTAL, command=self.show_color,
            background='pink')
        self.red_scale.set(255)
        self.red_scale.pack(side=tk.TOP, fill=tk.X, padx=5, pady=5)

        # Green.
        self.green_scale = tk.Scale(self.window, from_=0, to=255,
            orient=tk.HORIZONTAL, command=self.show_color,
            background='light green')
        self.green_scale.set(255)
        self.green_scale.pack(side=tk.TOP, fill=tk.X, padx=5, pady=(0,5))

        # Blue.
        self.blue_scale = tk.Scale(self.window, from_=0, to=255,
            orient=tk.HORIZONTAL, command=self.show_color,
            background='light blue')
        self.blue_scale.set(255)
        self.blue_scale.pack(side=tk.TOP, fill=tk.X, padx=5, pady=(0,5))

        # Hex display.
        self.hex_color_var = tk.StringVar(self.window, value='#ffffff')
        hex_color_entry = tk.Entry(self.window, state='readonly',
            textvariable=self.hex_color_var, justify='center')
        hex_color_entry.pack(side=tk.BOTTOM, fill=tk.X, pady=(0,5))

        # Canvas.
        self.canvas = tk.Canvas(self.window, bg='white', borderwidth=2,
                                relief=tk.SUNKEN)
        self.canvas.pack(side=tk.TOP, fill=tk.BOTH,
                         expand=True, padx=5, pady=(0,5))

        # Tkinter main loop.
        self.window.mainloop()

    def kill_callback(self):
        # Destroy the tkinter window.
        self.window.destroy()

    def show_color(self, _):
        r = self.red_scale.get()
        g = self.green_scale.get()
        b = self.blue_scale.get()
        color = f'#{r:02x}{g:02x}{b:02x}'
        self.canvas.configure(bg=color)
        self.hex_color_var.set(color)

# In[3]:

ColorSlidersApp()
print('Done')


# In[ ]:
